/* Copyright (c) 2003 by Vlad Galu */
#include "fmond.h"

TARGET	myfile[MAXFILES];
FILE	*errlog;

int main(int argc, char **argv) {
	int targets, i, kq;

	/* let's go into background */
	daemonize();
	
	/* we open our error logfile */
	errlog = fopen("/tmp/fmond.err", "w");

	/* now build the structure array */
	if ((targets = build_list()) != -1) { 
	 fprintf(errlog, "parse OK, we have %d files\n", targets);
	 syslog(LOG_WARNING | LOG_SECURITY, "watching %d files\n", targets);
	} else {
		fclose(errlog);
		syslog(LOG_WARNING | LOG_SECURITY, "encountered some errors, exiting\n");
		exit(0);
	  }
	
	/* let's build an event queue */
	if ((kq = kqueue()) == -1)
	 fprintf(errlog, "kqueue() failed: %s\n", strerror(errno));
	
	fclose(errlog);

	/* and submit some events to it */
	for (i=0;i<targets-1;i++)
	 if (myfile[i].path != NULL)
	 attach_fd(kq, myfile[i].fd, &myfile[i].path);
	
	/* entering monitoring loop */
	for (;;)
	 watch_fd(kq, targets);
	
	return 0;
}
	
void signal_handler(int sig) {
	int i;
	switch(sig) {
		case SIGHUP:
		 syslog(LOG_WARNING | LOG_SECURITY, "caught SIGHUP");
		 break;
        case SIGTERM:
		 syslog(LOG_WARNING | LOG_SECURITY, "caught SIGTERM, exiting");
		 for (i=getdtablesize();i>=0;i--) close(i);
		 unlink(LOCKFILE);
		 exit(0);
		 break;
	}
}
