/* Copyright (c) 2003 bu Vlad Galu */
#include "fmond.h"

void daemonize() {
	int i, lf;
	char *pid=NULL;
    if (getppid() == 1) return; /* we already were a daemon */
    i = fork();
    if (i<0) exit(1); else if (i>0) exit(0);
    setsid(); /* create a new session and become session leader */
    for (i=getdtablesize();i>=0;i--) close(i); /* close stdin, stdout, stderr */
    i = open("/dev/null", O_RDWR); dup(i); dup(i); /* redirect them to /dev/null */
    umask(027);
    if ((lf = open(LOCKFILE, O_RDWR | O_CREAT, 0640)) == -1) exit(1);
    if (lockf(lf, F_TLOCK, 0) < 0) exit(0); /* can't lock */
    pid = malloc(10); /* this is for you, ladybug! ;-) */
    sprintf(pid, "%d\n", getpid());
    write(lf, pid, strlen(pid));
    signal(SIGCHLD, SIG_IGN);
    signal(SIGTSTP, SIG_IGN);
    signal(SIGTTOU, SIG_IGN);
    signal(SIGTTIN, SIG_IGN);
    signal(SIGHUP, signal_handler);
    signal(SIGTERM, signal_handler);
    syslog(LOG_WARNING | LOG_SECURITY, "daemon started, PID is %d\n",
                                                    (pid_t)getpid());
}


int build_list() {
	extern FILE	*errlog;
	extern TARGET myfile[MAXFILES];
	FILE *fp; int i=0;
	
	syslog(LOG_WARNING | LOG_SECURITY, "array (re)initialized\n");
	fp = fopen("./fmond.conf", "r");
	while (!feof(fp)) {
	 myfile[i].path = malloc(MAXPATHLEN * sizeof(char));
	 fscanf(fp, "%s", myfile[i].path);
	 if (strlen(myfile[i].path) > 1)
      if ((myfile[i].fd = open(myfile[i].path, O_RDONLY | O_NONBLOCK)) == -1) {
		fprintf(errlog, "error in open(): %s, check perms for %s\n",
                                   strerror(errno), myfile[i].path);
		return -1;
	 }
	   else {
	    fprintf(errlog, "%s added\n", myfile[i].path);
	    i++;
	   }
	}
	fclose(fp);
	return i-1;
}
