/* Copyright (c) 2003 by Vlad Galu */
#include "fmond.h"

int attach_fd(int kq, int fd, void *udata) {
	struct kevent wlist;
	EV_SET(&wlist, fd, EVFILT_VNODE, EV_ADD | EV_ENABLE | EV_CLEAR,
						NOTE_DELETE | NOTE_WRITE    | NOTE_RENAME | \
				NOTE_LINK   | NOTE_REVOKE   | NOTE_ATTRIB, 0, (char*)udata);
	kevent(kq, &wlist, 1, NULL, 0, NULL);
	return 0;
}



void watch_fd(int kq, int targets) {
	struct kevent evlist;
	int nevs, i; char *syslogmsg, *evt;
	
	syslogmsg = malloc(255);
	evt = malloc(25);
	if ((nevs = kevent(kq, NULL, 0, &evlist, 1, NULL)) > 0) {
	 if (evlist.fflags & NOTE_RENAME)
	  evt = "been renamed";
	 if (evlist.fflags & NOTE_WRITE)
	  evt = "been written";
	 if (evlist.fflags & NOTE_DELETE)
	  evt = "been deleted (or modified)";
	 if (evlist.fflags & NOTE_LINK)
	  evt = "changed its link count";
	 if (evlist.fflags & NOTE_REVOKE)
	  evt = "been revoked access to";
	 if (evlist.fflags & NOTE_ATTRIB)
	  evt = "changed its attributes";
	 sprintf(syslogmsg, "%s %s %s", *(int*)evlist.udata, "has", evt);
	 syslog(LOG_WARNING | LOG_SECURITY, syslogmsg);
    }
}
